#include <CL_Conf.h>

#include <boost/algorithm/string.hpp>

using namespace inaf::oasbo::Configurators;

CLConfigurator::CLConfigurator(int argc, char **argv) :
		argc(argc), argv(argv) {
}

int CLConfigurator::pushConfigToSource(std::string target) {
	return 1;
}

int CLConfigurator::pushConfigToSource() {
	return 1;
}

int CLConfigurator::readConfigFromSource(std::string target) {
	for (int i = 1; i < argc-1; ++i) {
		std::string arg = argv[i];
		boost::to_lower(arg);
		size_t posTarget = arg.find("--"+target);
		size_t posSeparator = arg.find('_');
		if (posTarget == 0 && posSeparator == std::string("--"+target).size()) {
			std::string key = arg.substr(2);
			this->config[key] = argv[i+1];
		}
	}
	return 1;
}

int CLConfigurator::readConfigFromSource() {
	for (int i = 1; i < argc-1; ++i) {
		std::string arg = argv[i];
		size_t posDash = arg.find("--");
		size_t posSeparator = arg.find('_');
		if (posDash == 0 && posSeparator != std::string::npos) {
			std::string key = arg.substr(2);
			this->config[key] = argv[i+1];
		}
	}
	return 1;
}

int CLConfigurator::insert(std::map<std::string, std::string> conf,
		std::string target) {
	boost::to_lower(target);
	for (const auto &kvp : conf) {
		this->config[target + "_" + kvp.first] = kvp.second;
	}
	return 1;
}

